
var snipasteController = JSB.defineClass('snipasteController : UIViewController', {
  viewDidLoad: function() {
    self.appInstance = Application.sharedInstance();
    self.homeImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/home.png`), 2)
    self.gobackImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goback.png`), 2)
    self.goforwardImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goforward.png`), 2)
    self.screenImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/screen.png`), 2)
    self.snipasteImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/snipaste.png`), 2)
    self.appInstance = Application.sharedInstance();
    self.custom = false;
    self.customMode = "None"
    self.dynamic = true;
    self.miniMode = false;
    self.isLoading = false;
    self.lastFrame = self.view.frame;
    self.currentFrame = self.view.frame
    self.moveDate = Date.now()
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    self.view.layer.opacity = 1.0
    self.view.layer.cornerRadius = 12;

    // >>> DeepL view >>>
    self.webview = new UIWebView(self.view.bounds);
    // NSUserDefaults.standardUserDefaults().setObjectForKey('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15',"UserAgent")

    //  Application.sharedInstance().showHUD("error", self.view.window, 2);
    self.webview.backgroundColor = UIColor.whiteColor();
    self.webview.scalesPageToFit = true;
    self.webview.autoresizingMask = (1 << 1 | 1 << 4);
    self.webview.delegate = self;
    // self.webview.setValueForKey("Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15","User-Agent")
    self.webview.scrollView.delegate = self;
    self.webview.layer.cornerRadius = 15;
    self.webview.layer.masksToBounds = true;
    self.highlightColor = UIColor.blendedColor(
      UIColor.colorWithHexString("#2c4d81").colorWithAlphaComponent(0.8),
      Application.sharedInstance().defaultTextColor,
      0.8
    );
    // >>> DeepL langauge button >>>
    // self.webview.lanButton = UIButton.buttonWithType(0);
    // <<< DeepL langauge button <<<
    self.webview.hidden = true;
    self.webview.lastOffset = 0;
    self.view.addSubview(self.webview);
    // <<< DeepL view <<<

// >>> opacity button >>>
    // self.webAppButton.titleLabel.font = UIFont.systemFontOfSize(12);
    // <<< opacity button <<<
    // >>> close button >>>
    self.closeButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.closeButton,"closeButtonTapped:")
    self.closeButton.setTitleForState('✖️', 0);
    self.closeButton.titleLabel.font = UIFont.systemFontOfSize(10);
    // <<< close button <<<
    // >>> max button >>>
    self.maxButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.maxButton,"maxButtonTapped:")
    self.maxButton.setTitleForState('➕', 0);
    self.maxButton.titleLabel.font = UIFont.systemFontOfSize(10);
    // <<< max button <<<
    // >>> screen button >>>
    self.screenButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.screenButton,"changeScreen:")
    self.screenButton.setImageForState(self.screenImage,0)
    // <<< screen button <<<
    // >>> search button >>>
    self.searchButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.searchButton,"searchButtonTapped:")
    self.searchButton.setImageForState(self.snipasteImage,0)

    // self.searchButton.setTitleForState('🔍', 0);
    // <<< search button <<<
    // >>> move button >>>
    self.moveButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.moveButton)
    // <<< move button <<<
    // >>> goForward button >>>
    self.goForwardButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.goForwardButton,"goForwardButtonTapped:")
    self.goForwardButton.setImageForState(self.goforwardImage,0)
    // <<< goForward button <<<
      // >>> goBack button >>>
    self.goBackButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.goBackButton,"goBackButtonTapped:")
    self.goBackButton.setImageForState(self.gobackImage,0)
    // <<< goBack button <<<

    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    self.moveGesture.addTargetAction(self,"onMoveGesture:")

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.screenButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    self.resizeGesture.addTargetAction(self,"onResizeGesture:")
  },
  viewWillAppear: function(animated) {
    // Application.sharedInstance().showHUD("test", self.view.window, 2);

    // self.appInstance.showHUD("123",self.view.window,2)
    // UIView.beginAnimationsContext(undefined,undefined)
    // UIView.setAnimationDuration(10)
    // UIView.commitAnimations
    // UIView.animateWithDurationAnimations(10,1)
    self.webview.delegate = self;
  },
  viewWillDisappear: function(animated) {
    // self.appInstance.showHUD("123",self.view.window,2)

    self.webview.stopLoading();
    self.webview.delegate = null;
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
  },
viewWillLayoutSubviews: function() {
    if (self.miniMode) {
      // self.webview.hidden = true
      return
    }

    var viewFrame = self.view.bounds;
    var xLeft     = viewFrame.x
    var xRight    = xLeft + viewFrame.width
    var yTop      = viewFrame.y
    var yBottom   = yTop + viewFrame.height
    self.closeButton.frame = {x: xRight-18,y: yTop,width: 18,height: 18};
    self.maxButton.frame   = {x: xRight-43,y: yTop,width: 18,height: 18};
    self.screenButton.frame = {x: xRight - 37,y: yBottom - 30,width: 30,height: 25};
    self.moveButton.frame = {  x: xRight*0.5-75,  y: yTop,  width: 150,  height: 12,};
    self.searchButton.frame = {  x: xRight - 72,  y: yBottom - 30,  width: 30,  height: 25,}
    self.goBackButton.frame = {  x: xLeft+6,  y: yBottom - 30,  width: 30,  height: 25,};
    self.goForwardButton.frame = {  x: xLeft+41,  y: yBottom - 30,  width: 30,  height: 25,};
    self.webview.frame = {x:xLeft+1,y:yTop+6,width:viewFrame.width-2,height:viewFrame.height-6}
  },
  scrollViewDidScroll: function() {
  },
  webViewDidStartLoad: function(webView) {
    let currentURL = webView.request.URL().absoluteString()
    //  Application.sharedInstance().showHUD(webView.request.URL().absoluteString(), self.view.window, 2);
    
    if (/^marginnote3app/.test(currentURL)) {
     Application.sharedInstance().showHUD("Return to source...", self.view.window, 2);
    // self.appInstance.studyController(self.view.window).focusNoteInMindMapById(currentURL.match(/(?<=^marginnote3app:\/\/note\/).*/))
      Application.sharedInstance().openURL(NSURL.URLWithString(currentURL));
      webView.stopLoading();
      return
    }
  },
  webViewDidFinishLoad: function(webView) {
    let currentURL = webView.request.URL().absoluteString()
    // self.appInstance.showHUD(currentURL, self.view.window, 2);
    self.goBackButton.hidden = !webView.canGoBack
    self.goForwardButton.hidden = !webView.canGoForward
    if (!self.htmlMode) {
      return
    }
    webView.evaluateJavaScript(`
      document.getElementsByClassName("body")[0].offsetHeight
    `,ret=>{
      if (ret !== NSNull.new()) {
        // Application.sharedInstance().showHUD(ret, self.view.window, 2);
        let viewFrame = self.view.frame
        let windowHeight = self.appInstance.studyController(self.view.window).view.bounds.height
        if (viewFrame.y+parseFloat(ret)+40 >= windowHeight) {
          viewFrame.height = windowHeight-viewFrame.y
        }else{
          viewFrame.height = parseFloat(ret)+40
        }
        self.view.frame = viewFrame
        self.currentFrame = viewFrame
        if (self.view.hidden) {
          self.show()
        }
      }
    })
  },
  webViewDidFailLoadWithError: function(webView, error) {
  },

  changeScreen: function(sender) {
    //  Application.sharedInstance().showHUD(self.appearOnNewExcerpt, self.view.window, 2);
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();

    menuController.commandTable = [
      {title:'🌗 Left',object:self,selector:'leftButtonTapped:',param:'left',checked:self.customMode==="left"},
      {title:'🌘 Left 1/3',object:self,selector:'left13ButtonTapped:',param:'left',checked:self.customMode==="left13"},
      {title:'🌓 Right',object:self,selector:'rightButtonTapped:',param:'right',checked:self.customMode==="right"},
      {title:'🌒 Right 1/3',object:self,selector:'right13ButtonTapped:',param:'right',checked:self.customMode==="right13"},
      {title:'📋 From pasteboard',object:self,selector:'snipasteFromPasteboard:',param:'right'},
      {title:'🫧 Opacity',object:self,selector:'changeOpacity:',param:sender},
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 250,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacity: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    menuController.commandTable = [
      {title:'100%',object:self,selector:'changeOpacityTo:',param:1.0},
      {title:'90%',object:self,selector:'changeOpacityTo:',param:0.9},
      {title:'80%',object:self,selector:'changeOpacityTo:',param:0.8},
      {title:'70%',object:self,selector:'changeOpacityTo:',param:0.7},
      {title:'60%',object:self,selector:'changeOpacityTo:',param:0.6},
      {title:'50%',object:self,selector:'changeOpacityTo:',param:0.5}
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 100,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
    // self.webAppButton.setTitleForState(`${opacity*100}%`, 0);
  },
  snipasteFromPasteboard:function (opacity) {
    let image = UIPasteboard.generalPasteboard().image
    if (image) {
      let wholeFrame = self.appInstance.studyController(self.view.window).view.bounds
      let imageSize = image.size
      let widthScale = wholeFrame.width/imageSize.width*0.5
      let heightScale = wholeFrame.height/imageSize.height*0.5
      let scale = Math.min(widthScale,heightScale)
      if (scale > 1) {
        scale = 1
      }
      // let scale = (imageSize.width < 600 || imageSize.height < 200)?1.0:0.5
      // Application.sharedInstance().showHUD("width: "+imageSize.width+" hiehgt: "+imageSize.height, self.view.window, 2)
      let viewFrame = self.view.frame
      self.view.frame = {x:viewFrame.x,y:viewFrame.y,width:imageSize.width*scale,height:imageSize.height*scale}
      self.currentFrame = {x:viewFrame.x,y:viewFrame.y,width:imageSize.width*scale,height:imageSize.height*scale}
      let imageData = image.pngData()
      self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(`data:image/png;base64,${imageData.base64Encoding()}`)))
      self.htmlMode = false
    }else{
      self.appInstance.showHUD("No image in pasteboard", self.view.window, 2)
    }

  },
  searchButtonTapped: function() {
    let docMapSplitMode = self.appInstance.studyController(self.view.window).docMapSplitMode
      // Application.sharedInstance().showHUD("studymode: "+self.appInstance.studyController(self.view.window).docMapSplitMode, self.view.window, 2)
    let imageData = self.appInstance.studyController(self.view.window).readerController.documentControllers[0].imageFromSelection()
    if (!imageData) {
      let focusNote
      if (docMapSplitMode===0) {
        focusNote = self.appInstance.studyController(self.view.window).notebookController.focusNote
      }else{
        focusNote = self.appInstance.studyController(self.view.window).readerController.documentControllers[0].focusNote
      }
    //   imageData = self.appInstance.studyController(self.view.window).readerController.documentControllers[0].imageFromFocusNote()
    // }
    // if (!imageData || docMapSplitMode===0) {
      // let focusNote = self.appInstance.studyController(self.view.window).notebookController.focusNote
      if (focusNote && focusNote.excerptPic && !focusNote.noteTitle && !focusNote.comments.length) {
        imageData = Database.sharedInstance().getMediaByHash(focusNote.excerptPic.paint)
      }else{
        imageData = undefined
      }
    }
    if (imageData) {
      let image = UIImage.imageWithData(imageData)
      let wholeFrame = self.appInstance.studyController(self.view.window).view.bounds
      // let rotateImage = UIImage.imageWithCGImageScaleOrientation(image.CGImage,1.5,UIImage.orientation)
      // rotateImage.imageOrientation = 1
      // let rotateImageData = rotateImage.pngData()
      let imageSize = image.size
      let widthScale = wholeFrame.width/imageSize.width*0.5
      let heightScale = wholeFrame.height/imageSize.height*0.5
      let scale = Math.min(widthScale,heightScale)
      if (scale > 1) {
        scale = 1
      }
      // let scale = (imageSize.width < 600 || imageSize.height < 200)?1.0:0.5
      // Application.sharedInstance().showHUD("width: "+imageSize.width+" hiehgt: "+imageSize.height, self.view.window, 2)
      let viewFrame = self.view.frame
      self.view.frame = {x:viewFrame.x,y:viewFrame.y,width:imageSize.width*scale,height:imageSize.height*scale}
      self.currentFrame = {x:viewFrame.x,y:viewFrame.y,width:imageSize.width*scale,height:imageSize.height*scale}
      // style="transform:rotate(7deg)"
      self.htmlMode = false
      self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(`data:image/png;base64,${imageData.base64Encoding()}`)))
      // self.webview.loadHTMLStringBaseURL(`
      // <img style="transform:rotate(7deg)" width="100%" src="data:image/jpeg;base64,${imageData.base64Encoding()}"/>`)
      // self.webview.loadHTMLStringBaseURL(`<a href="marginnote3app://note/C08E37FD-AC36-42BB-A8AB-739296E62F23">test</a>`)
      self.view.hidden = false
      self.webview.hidden = false
      // Application.sharedInstance().showHUD(123, self.view.window, 2)

    }else{
      let focusNote
      if (docMapSplitMode===0) {
        focusNote = self.appInstance.studyController(self.view.window).notebookController.focusNote
      }else{
        focusNote = self.appInstance.studyController(self.view.window).readerController.documentControllers[0].focusNote
      }
      if (focusNote) {
        self.snipasteNote(focusNote)
      }else{
        self.appInstance.showHUD("No image or note selected", self.view.window, 2)
      }
    }
  },
  goBackButtonTapped: function() {
    self.webview.goBack();
  },
  goForwardButtonTapped: function() {
    self.webview.goForward();
  },
  closeButtonTapped: function() {
    self.hide()
    // self.view.hidden = true;
    },
  leftButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    self.lastFrame = self.view.frame
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:50,width:splitLine-40,height:height-50}
    self.custom = true;
    self.customMode = "left"
    self.dynamic = false;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  left13ButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.customMode = "left13"
    self.dynamic = false;
    self.lastFrame = self.view.frame

    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:60,width:studyFrame.width/3.+40,height:height-60}
    self.custom = true;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  rightButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.customMode = "right"
    self.dynamic = false;
    self.lastFrame = self.view.frame
    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.custom = true;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  right13ButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.custom = true;
    self.customMode = "right13"
    self.dynamic = false;
    self.lastFrame = self.view.frame
    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  maxButtonTapped: function() {
    if (self.customMode === "full") {
      self.customMode = "none"
      self.custom = false;
      self.view.frame = self.lastFrame
      return
    }
    const frame = Application.sharedInstance().studyController(this.window).view.bounds
    self.lastFrame = self.view.frame
    self.view.frame = {x:40,y:50,width:frame.width-80,height:frame.height-70}
    self.customMode = "full"
    self.custom = true;
    self.dynamic = false;
    self.webview.hidden = false
  },
  onMoveGesture:function (gesture) {
    self.dynamic = false;
    let locationToMN = gesture.locationInView(self.appInstance.studyController(self.view.window).view)
    if (!self.miniMode && (Date.now() - self.moveDate) > 100) {
      // self.appInstance.showHUD("state:"+gesture.state, self.view.window, 2);
      let translation = gesture.translationInView(self.appInstance.studyController(self.view.window).view)
      let locationToBrowser = gesture.locationInView(self.view)
      let locationToButton = gesture.locationInView(gesture.view)
      let buttonFrame = self.moveButton.frame
      let newY = locationToButton.y-translation.y 
      let newX = locationToButton.x-translation.x
      if (gesture.state !== 3 && (newY<buttonFrame.height && newY>0 && newX<buttonFrame.width && newX>0 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20)) {
        self.locationToBrowser = {x:locationToBrowser.x-translation.x,y:locationToBrowser.y-translation.y}
        self.locationToButton = {x:newX,y:newY}
      }
      // if ((newY<buttonFrame.height && newY>0 && newX<buttonFrame.width && newX>0 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20) || !self.locationToBrowser) {

      // }
    }
    self.moveDate = Date.now()
    // let location = {x:locationToMN.x - self.locationToBrowser.x,y:locationToMN.y -self.locationToBrowser.y}
    let location = {x:locationToMN.x - self.locationToButton.x-gesture.view.frame.x,y:locationToMN.y -self.locationToButton.y-gesture.view.frame.y}


    let frame = self.view.frame
    var viewFrame = self.view.bounds;
    let studyFrame = self.appInstance.studyController(self.view.window).view.bounds
    let y = location.y
    if (y<=0) {
      y = 0
    }
    if (y>=studyFrame.height-15) {
      y = studyFrame.height-15
    }
    let x = location.x
    if (!self.miniMode) {
      if (locationToMN.x<40) {
        self.miniMode = true 
        self.dynamic = false    
        self.lastFrame = frame 
        self.webview.hidden = true

        self.currentFrame  = self.view.frame
        self.closeButton.hidden = true
        self.maxButton.hidden = true
        self.moveButton.hidden = true
        self.screenButton.hidden = true
        self.searchButton.hidden = true
        self.goBackButton.hidden = true
        self.goForwardButton.hidden = true

        self.view.layer.borderWidth = 3
        self.view.layer.borderColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8)
        UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
          self.view.frame = {
            x:0,
            y:locationToMN.y,
            width:40,
            height:40
          }
          self.currentFrame  = self.view.frame
        },
        ()=>{
          self.moveButton.frame = {
            x: 0,
            y: 0,
            width: 40,
            height: 40,
          };
          self.moveButton.hidden = false
          self.closeButton.hidden = true
          self.maxButton.hidden = true
        })
        return
      }
      if (locationToMN.x>studyFrame.width-40) {
        x=studyFrame.width-frame.width*0.5-40
        self.miniMode = true     
        self.dynamic = false    
        self.lastFrame = frame 
        self.webview.hidden = true
        self.currentFrame  = self.view.frame
        self.closeButton.hidden = true
        self.maxButton.hidden = true
        self.moveButton.hidden = true
        self.screenButton.hidden = true
        self.searchButton.hidden = true
        self.goBackButton.hidden = true
        self.goForwardButton.hidden = true
        self.view.layer.borderWidth = 3
        self.view.layer.borderColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8)
        UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
          self.view.frame = {
            x:studyFrame.width-40,
            y:frame.y,
            width:40,
            height:40
          }
          self.currentFrame  = self.view.frame
        },
        ()=>{
          self.moveButton.frame = {
            x: 0,
            y: 0,
            width: 40,
            height: 40,
          };
          self.moveButton.hidden = false
          self.closeButton.hidden = true
          self.maxButton.hidden = true

        })
        return
      }
    }else{
      if (locationToMN.x<50) {
        self.view.frame = {
          x:0,
          y:locationToMN.y-20,
          width:40,
          height:40
        }
        return
      }else if (locationToMN.x>studyFrame.width-50) {
        self.view.frame = {
          x:studyFrame.width-40,
          y:locationToMN.y-20,
          width:40,
          height:40
        }
        return
      }else if (locationToMN.x>50) {
        let preOpacity = self.view.layer.opacity
        self.view.layer.opacity = 0
        self.moveButton.hidden = true
        self.closeButton.hidden = true
        self.maxButton.hidden = true
        UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
          self.view.frame = {
            x:x,
            y:y,
            width:self.lastFrame.width,
            height:self.lastFrame.height
          }
          self.view.layer.opacity = preOpacity
          self.currentFrame = self.view.frame
        },
        ()=>{
          self.moveButton.frame = {
            x: viewFrame.x + viewFrame.width*0.5-75,
            y: viewFrame.y + 5,
            width: 150,
            height: 10,
          };
          self.moveButton.hidden = false
          self.view.layer.borderWidth = 0
          // self.view.layer.borderColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8)
          self.view.hidden = false
          self.webview.hidden = false
          self.closeButton.hidden = false
          self.maxButton.hidden = false
          self.screenButton.hidden = false
          self.searchButton.hidden = false
          self.goBackButton.hidden = !self.webview.canGoBack
          self.goForwardButton.hidden = !self.webview.canGoForward
        })
        self.miniMode = false
        return
      }
    }
    
    if (self.custom) {
      // Application.sharedInstance().showHUD(self.custom, self.view.window, 2);
      self.customMode = "None"
      UIView.animateWithDurationAnimations(0.2,()=>{
        self.view.frame = {x:x,y:y,width:self.lastFrame.width,height:self.lastFrame.height}
        self.currentFrame  = self.view.frame
      })

    }else{
      self.view.frame = {x:x,y:y,width:frame.width,height:frame.height}
      self.currentFrame  = self.view.frame

    }
    self.custom = false;
  },
  onResizeGesture:function (gesture) {
    self.custom = false;
    self.dynamic = false;
    let baseframe = gesture.view.frame
    let locationInView = gesture.locationInView(gesture.view)
    let frame = self.view.frame
    let width = locationInView.x+baseframe.x+baseframe.width*0.5
    let height = locationInView.y+baseframe.y+baseframe.height*0.5
    if (width <= 200) {
      width = 200
    }
    if (height <= 100) {
      height = 100
    }
    //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
    //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
    self.view.frame = {x:frame.x,y:frame.y,width:width,height:height}
    self.currentFrame  = self.view.frame
  },
});
snipasteController.prototype.setButtonLayout = function (button,targetAction) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
    button.layer.cornerRadius = 10;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}
snipasteController.prototype.snipasteNote = function (focusNote) {
  this.htmlMode = true
  let title = focusNote.noteTitle?focusNote.noteTitle:"..."
  let excerpt = focusNote.excerptText
  if (focusNote.excerptPic) {
    imageData = Database.sharedInstance().getMediaByHash(focusNote.excerptPic.paint)
    excerpt = `<img width="100%" src="data:image/jpeg;base64,${imageData.base64Encoding()}"/>`
  }
  let noteColorHexes = ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9edc"]
  let theme = this.appInstance.currentTheme
  let themeHtml = `      
    body{
      -webkit-text-fill-color: rgb(0, 0, 0);
    }`
  if (theme === "Gray") {
    noteColorHexes = ["#d2d294","#a8d1a1","#94accf","#c88f9d","#d2d244","#5fcf3d","#459acd","#c0281b","#c46f28","#2c683a","#12328e","#9c281c","#d2d2d2","#b4b4b4","#949494","#9c82b5"]
    themeHtml = `      
    body{
      background-color: #414141;
      -webkit-text-fill-color: rgb(255, 255, 255);
    }`
  }else if (theme === "Dark") {
    noteColorHexes = ["#a0a071","#809f7b","#71839e","#986d77","#a0a032","#479e2c","#33759c","#921c12","#96551c","#204f2c","#0c266c","#771e14","#a0a0a0","#898989","#717171","#77638a"]
    themeHtml = `      
    body{
      background-color: #121212;
      -webkit-text-fill-color: rgb(233, 232, 232);
    }`
  }
  let comments = focusNote.comments.map(comment=>{
    try {
      switch (comment.type) {
        case "TextNote":
          if (/^marginnote3app:\/\//.test(comment.text)) {
            return ""
          }
          return `\n<div>${comment.text}</div>`
        case "PaintNote":
          if (comment.paint) {
            let commentImage = Database.sharedInstance().getMediaByHash(comment.paint)
            return `\n<img width="100%" src="data:image/jpeg;base64,${commentImage.base64Encoding()}"/>`
          }else{
            return ""
          }
        case "HtmlNote":                  
          return "\m"+comment.html
        case "LinkNote":
          let note = Database.sharedInstance().getNoteById(comment.noteid)
          if (note && note.excerptPic) {
            let imageData = Database.sharedInstance().getMediaByHash(note.excerptPic.paint)
            return `\n<img width="100%" src="data:image/jpeg;base64,${imageData.base64Encoding()}"/>`
          }else{
            return `\n<div>${comment.q_htext}</div>`
          }
        default:
          return "";
      }
    } catch (error) {
      Application.sharedInstance().showHUD(error, this.view.window, 2)
      return ""
    }
  }).join("")
  let noteid  = focusNote.noteId
  let excerptHtml = excerpt?`      <a href="marginnote3app://note/${noteid}">
        <p class="excerpt">${excerpt}</p>
      </a>`:""
  let html = `
  <html lang="en">

  <head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <style>
      ${themeHtml}
      .body {
        border: 3px solid ${noteColorHexes[focusNote.colorIndex]};
        border-radius: 10px 10px 10px 10px;
        font-size: large;
      }
      .head {
        background-color: ${noteColorHexes[focusNote.colorIndex]};
        border-radius: 6px 6px 0px 0px;
        line-height: 30px;
      }
      .tail {
        height: 10px;
      }
      .title {
        padding-left: 10px;
        padding-bottom: 5px;
      }
      .excerpt {
        white-space: pre-line;
        padding-left: 10px;
      }
      .comment {
        white-space: pre-line;
        padding-left: 10px;
      }
    </style>
  </head>

  <body>
    <div class="body">
      <div class="head">
        <div class="title">
        ${title}
        </div>
      </div>
      ${excerptHtml}
      <div class="comment">${comments.trim()}</div>
      <div class="tail"></div>
    </div>
  </body>
  </html>
            `
  this.webview.loadHTMLStringBaseURL(html)
  // if (this.view.hidden) {
  //   this.show()
  // }
}
snipasteController.prototype.show = function () {
  let preFrame = this.view.frame
  let preOpacity = this.view.layer.opacity
  this.view.layer.opacity = 0.2
  this.view.hidden = false
  this.moveButton.hidden = true
  this.closeButton.hidden = true
  this.maxButton.hidden = true
  this.webview.hidden = false
  if (this.toolbarOn) {
    this.engineButton.hidden = true
  }
  UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
    this.view.layer.opacity = preOpacity
    this.view.frame = preFrame
    this.currentFrame = preFrame
  },
  ()=>{
    this.moveButton.hidden = false
    this.closeButton.hidden = false
    this.maxButton.hidden = false
    this.webview.hidden = false
  })
}
snipasteController.prototype.hide = function () {
  let preFrame = this.view.frame
  let preOpacity = this.view.layer.opacity
  // let preFrame = this.view.frame
  this.webview.hidden = false
  this.moveButton.hidden = true
  this.closeButton.hidden = true
  this.maxButton.hidden = true
  UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
    this.view.layer.opacity = 0.2
  },
  ()=>{
    this.view.hidden = true;
    this.view.layer.opacity = preOpacity      
    this.view.frame = preFrame
    this.currentFrame = preFrame
  })
}
function getSplitLine() {
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let readerFrame = Application.sharedInstance().studyController(this.window).readerController.view.frame
    let hidden = Application.sharedInstance().studyController(this.window).readerController.view.hidden//true代表脑图全屏
    let rightMode = Application.sharedInstance().studyController(this.window).rightMapMode
    let fullWindow = readerFrame.width == studyFrame.width
    if (hidden || fullWindow) {
      let splitLine = studyFrame.width*0.5
      return splitLine
    }
    if (rightMode) {
      let splitLine = readerFrame.x+readerFrame.width
      return splitLine
    }else{
      let splitLine = readerFrame.x
      return splitLine
    }
  }